package com.perisic.beds.Machine;
import java.util.Vector;

/**
 * This class keeps track of deposited items, calculates the value to add to the receipt and can return it as a string.
 * @author AH
 */
public class ReceiptBasis
{
    private Vector<DepositItem> myItems = new Vector<DepositItem>();
    /**
     * This method is used to add items to the machine
     * @param item The most recently deposited item
     */
    public void addItem(DepositItem item)
    {
        myItems.add(item);
        item.number = myItems.indexOf(item);
    }
    /**
     * This method calculates the total value of all deposited items
     * @return A string formatted to be printed on a receipt
     */
    public String computeSum()
    {
        String receipt = "";
        int sum = 0;
        for (DepositItem item : myItems)
        {
            receipt = receipt + (item.number + 1) + ": " + item.getName() + " worth " + item.value;
            receipt = receipt + System.getProperty("line.separator");
            sum = sum + item.value;
        }
        receipt = receipt + "Total: "+sum;
        return receipt;
    }
}
