package com.perisic.beds.Control;


import javax.swing.*;
import java.util.Vector;

/**
 * This thread displays and handles teh results of a dialog, so that the control form does not have to become cluttered or unresponsive
 * @author AH, AM, SA
 */
public class OptionThread extends Thread
{
    private MachineConnection mc;

    /**
     * @param con The MachineConnection corresponding to the machine that is to be interacted with
     */
    public OptionThread(MachineConnection con)
    {
        mc = con;
    }

    public void run()
    {
        String[] values = {"Empty Machine", "View Customer Feedback", "Cancel"};
        int n = JOptionPane.showOptionDialog(null, "",
                                             "Additional functions",
                                             JOptionPane.YES_NO_CANCEL_OPTION,
                                             JOptionPane.QUESTION_MESSAGE, null, values, values[2]);
        switch(n)
        {
            case 0:
                //Empty
                emptyMachine();
                break;
            case 1:
                //Feedback
                getFeedback();
                break;
            case 2:
                //exit
                break;
            default:
                //exit
                break;
        }
    }

    /**
     * Empties the remote machine
     */
    private void emptyMachine()
    {
        mc.emptyMachine();
    }

    /**
     * Displays the feedback from the remote machine in a message dialog
     */
    private void getFeedback()
    {
        Vector<String> feedback = mc.getFeedback();

        JTextArea ta = new JTextArea();
        ta.setEditable(false);

        if(!feedback.isEmpty())
        {
            int i = 1;
            for(String s : feedback)
            {
                ta.append(i + ": " + s + "\n\r\n\r");
                i++;
            }
        }

        JScrollPane sp = new JScrollPane(ta);

        JOptionPane.showMessageDialog(null, sp,
                                      "Customer Feedback",JOptionPane.INFORMATION_MESSAGE);
    }
}