package com.perisic.beds.Control;

import javax.swing.*;
import java.awt.*;

/**
 * This thread will constantly update the item count of a remote machine. This also prevents the login session from expiring. This thread will also display a message when the machine is full.
 * @author AH, AM, SA
 */
public class PingThread extends Thread
{
    private MachineConnection mc;
    private JLabel lab;
    private boolean warned;

    /**
     * @param conn A connection to a remote machine
     * @param label The label to update
     */
    public PingThread(MachineConnection conn, JLabel label)
    {
        super();
        mc = conn;
        lab = label;
        warned = false;
    }

    /**
     * This thread will constantly update the item count of a remote machine. This also prevents the login session from expiring. This thread will also display a message when the machine is full.
     */
    public void run()
    {
        try
        {
            Thread.sleep(5000);
            if (!mc.empty)
            {
                int total = mc.getTotal();
                lab.setText(total + " /100");
                if(total >= 100)
                {
                    lab.setForeground(Color.RED);
                    if(!warned)
                    {
                        warned = true;
                        MessageThread mt = new MessageThread("Machine full!");
                        mt.start();
                    }
                }
                else
                {
                    lab.setForeground(new Color(0,0,0));
                }
                run();
            }
        }
        catch (InterruptedException ex)
        {
            return;
        }
    }
}
