package com.perisic.beds.Machine;

/**
 * This thread is used to expire the current cookie after a period of inactivity
 * @author AH, AM, SA
 */
public class ConnectionReset extends Thread
{
    private CookieManager cm;

    /**
     * @param c The cookie that should be expired
     */
    public ConnectionReset(CookieManager c)
    {
        super();
        cm = c;
    }

    /**
     * Sleeps and then expires the cookie unless interrupted.
     */
    public void run()
    {
        try
        {
            Thread.sleep(30000);
            cm.logout();
        }
        catch(InterruptedException e)
        {
            return;
        }
    }
}
