package com.perisic.beds.Machine;

/**
 * This class handles cookies
 * @author AH, AM, SA
 */
public class CookieManager
{
    private String activeCookie = "none";

    /**
     * Compares given cookie to stored cookie
     * @param cookie The cookie to check
     * @return Whether the given cookie is a match for the stored cookie
     */
    public boolean checkCookie(String cookie)
    {
        if(activeCookie.equals("none"))
        {
            return false;
        }
        else if(cookie.equals(activeCookie))
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Checks whether the machine has not been logged into
     * @return whether the machine has not been logged into
     */
    public boolean available()
    {
        if(activeCookie.equals("none"))
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * @return The active cookie
     */
    public String get()
    {
        return activeCookie;
    }

    /**
     * @param cookie The new cookie
     */
    public void set(String cookie)
    {
        activeCookie = cookie;
    }

    /**
     * Deletes the active cookie
     */
    public void logout()
    {
        activeCookie = "none";
    }
}
