package com.perisic.beds.Machine;

import java.util.Vector;

/**
 * This class is the frontend of the package
 * @author AH
 */
public class CustomerPanel
{
    private DepositItemReceiver receiver = null;

    //    private String activeCookie = "none";
    private CookieManager cm = null;
    private String name = "";
    private ConnectionReset cr;
    private Feedback  fb;

    private void connectionRenewed()
    {
        if(cr != null)
        {
            cr.interrupt();
        }
        cr = new ConnectionReset(cm);
        cr.start();
    }

    public void leaveFeedback(String feedback)
    {
        fb.leaveFeedback(feedback);
    }

    public Vector<String> getFeedback(String cookie)
    {
        if(cm.checkCookie(cookie))
        {
            connectionRenewed();
            /*if(fb != null)
            {*/
            return fb.getFeedback();
//            }
/*            else
            {
                Vector<String> v = new Vector<String>();
                v.add("No feedback left");
                return v;
            }*/
        }
        else
        {
            Vector<String> v = new Vector<String>();
            v.add("Bad cookie");
            return v;
        }
    }

    public int emptyMachine(String cookie)
    {
        if(cm.checkCookie(cookie))
        {
            connectionRenewed();
            receiver.emptyMachine();
            return 1;
        }
        else
        {
            return -1;
        }
    }

    public int getItemCount(String cookie)
    {
        if(cm.checkCookie(cookie))
        {
            connectionRenewed();
            return receiver.getTotal();
        }
        else
        {
            return -1;
        }
    }

    public Vector<String> getDetailedTotal(String cookie)
    {
        Vector<String> ret = new Vector<String>();
        if(cm.checkCookie(cookie))
        {
            connectionRenewed();
            int [] i =receiver.getDetailedTotal();
            for(int x = 0; x < i.length; x++)
            {
                ret.add("" + i[x]);
            }
            return ret;
        }
        else
        {
            ret.add("-1");
            return ret;
        }
    }

    public String login(String pass)
    {
        if(pass.equals("password"))
        {
            if(cm.available())
            {
                cm.set("A" + Math.random());
                connectionRenewed();
                System.out.println(cm.get());
                return cm.get();
            }
            else
            {
                return "already logged";
            }
        }
        else
        {
            return "bad password";
        }
    }

    public String logout()
    {
        cr.interrupt();
        cm.logout();
        return "logged out";
    }

    /**
     * Calls the classifyItem method of the DepositItemReceiver class
     * @param slot An int that corresponds with the slot the item was entered in
     * @throws MachineFullException Thrown when machine is full.
     */
    public void itemReceived(int slot) throws MachineFullException
    {
        receiver.classifyItem(slot);
    }
    /**
     * Calls the printReceipt method of the DepositItemReceiver class
     */
    public void printReceipt()
    {
        receiver.printReceipt();
    }

    /**
     * Constructor.
     * @param printer The Printerface to be used to output receipts
     */
    public CustomerPanel(Printerface printer)
    {
        super();
        receiver = new DepositItemReceiver(printer);
        cm = new CookieManager();
        fb = new Feedback();
    }

}
